# 出荷チェッカーの使い方

このページではデータベースを活用した**出荷チェッカー**の使い方を説明します。

![出荷チェッカー仕様例](./assets/dispatch_checker_example.png)

## 事前準備
このアプリを使うには以下の3つが必要です。

1. julia
2. このgitリポジトリ
3. データベースファイル

### julia
[簡易試験結果閲覧アプリの使い方](./howtouse-simpleviewer.md#julia)を参照してください。

### このgitリポジトリ
このページの右上から飛べます。

### データベースファイル
[Tutorial](./tutorial.md)にかかれています。
このプロジェクト(git)のルートにおいてください。

## 実行
まずはjuliaを起動します。
ターミナルでプロジェクトのルート(`Project.toml`がある場所)に移動して以下のオプションとともに`julia`を起動してください。
```sh
$ julia --project
```

!!! tip
    `-t auto`とするとマルチスレッドで起動します。

!!! tip
    `using OhMyREPL`とするとREPLでシンタックスハイライトがつくようになります。

次に、パッケージを読み込みます。
```julia
using PSBoardDataBase
```

そして、[`PSBoardDataBase.DispatchChecker.interactive_dispatch_checker`](@ref)をデータベースのパスを与えて実行します。
```julia
PSBoardDataBase.DispatchChecker.interactive_dispatch_checker("psboard_qaqc.db")
```

しばらくすると`PSBoard ID: `と表示されるので、出荷チェックを行いたいPSBoardのQRコードを読むと(もしくはPS00xxxxと手入力すると)、そのPSBoardの試験結果をとってきて、**出荷可能な場合は`Ok`と表示**されます。
出荷可能でない場合は`No`と表示されます[^1]。
出荷可能かわからない場合は試験結果がすべて表示されるので、それをみて判断します(yまたはnを入れてEnter)。

[^1]: 現状表示されることはないです

最後に"Finished"のあとにPSxxxxxxがプリントされるので、それをコピーしてスプレッドシートの出荷のところに書いてください[^2]。

[^2]: もしくは返り値としてPSBoard IDの`Vector`が返ってくるのでそれを使ってください
